unit Unit1;

interface

{Ovo je primer dinamickog povezivanja sa DLL-om}

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TDLLDescFunc = function: ShortString;
  TOperationFunc = function(A, B: Double): Double;

  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Button3: TButton;
    Edit3: TEdit;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
    Lib: THandle;
    DLLDescFunc: TDLLDescFunc;
    OperationFunc: TOperationFunc;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  F1, F2: TFarProc;
begin
  if OpenDialog1.Execute then
  begin
    if Lib <> 0 then Button2.Click;
    Lib := LoadLibrary(PChar(OpenDialog1.FileName));
    if Lib <> 0 then
    begin
      F1 := GetProcAddress(Lib, 'GetDLLDesc');
      F2 := GetProcAddress(Lib, 'Operation');
      if (F1 <> nil) and (f2 <> nil) then
      begin
        DLLDescFunc := F1;
        OperationFunc := F2;
        Application.MessageBox('DLL je uspesno ucitan', 'Info');
        Label1.Caption := DLLDescFunc;
      end
      else
      begin
        Application.MessageBox('DLL ne sadrzi potrebne funkcije', 'Info');
        Button2.Click;
      end;
    end
    else
      Application.MessageBox('Greska pri ucitavanju DLLa', 'Info');
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if Lib <> 0 then
    if FreeLibrary(Lib) then
      Application.MessageBox('DLL je unloadovan', 'Info')
    else
      Application.MessageBox('Greska pri unloadovanju DLLa', 'Info');
  Label1.Caption := 'DLL nije ucitan';
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if Lib <> 0 then
    Edit3.Text := FloatToStr(OperationFunc(StrToFloat(Edit1.Text), StrToFloat(Edit2.Text)));
end;

end.
